  Redmine::WikiFormatting::Macros.register do
    desc 'Related table'
    macro :related_table do |obj, args|

      str = ""
      if obj.class == Issue

        relateds = []

        obj.relations.each do |r|
          other = r.other_issue(obj)
          if args.empty? or args.include?(other.tracker.name)
            relateds.push(other)
          end
        end

        relateds = relateds.sort_by{|i|i.due_date}

        str += "<table>"

        if Setting.plugin_issue_table_macro['issue_table_num']
          str += "<th>#{l(:settings_issue_table_num)}</th>"
        end
        if Setting.plugin_issue_table_macro['issue_table_issue']
          str += "<th>#{l(:field_issue)}</th>"
        end
        if Setting.plugin_issue_table_macro['issue_table_status']
          str += "<th>#{l(:field_status)}</th>"
        end
        if Setting.plugin_issue_table_macro['issue_table_fixed_version']
          str += "<th>#{l(:field_fixed_version)}</th>"
        end
        if Setting.plugin_issue_table_macro['issue_table_priority']
          str += "<th>#{l(:field_priority)}</th>"
        end
        if Setting.plugin_issue_table_macro['issue_table_category']
          str += "<th>#{l(:field_category)}</th>"
        end
        if Setting.plugin_issue_table_macro['issue_table_subject']
          str += "<th>#{l(:field_subject)}</th>"
        end
        if Setting.plugin_issue_table_macro['issue_table_author']
          str += "<th>#{l(:field_author)}</th>"
        end
        if Setting.plugin_issue_table_macro['issue_table_assigned_to']
          str += "<th>#{l(:field_assigned_to)}</th>"
        end
        if Setting.plugin_issue_table_macro['issue_table_start_date']
          str += "<th>#{l(:field_start_date)}</th>"
        end
        if Setting.plugin_issue_table_macro['issue_table_due_date']
          str += "<th>#{l(:field_due_date)}</th>"
        end


        i = 1
        relateds.each do |r|
          str += "<tr>"
          if Setting.plugin_issue_table_macro['issue_table_num']
            str += "<td>#{i}</td>"
          end
          if Setting.plugin_issue_table_macro['issue_table_issue']
            str += "<td>#{link_to_issue(r, :subject => false)}</td>"
          end
          if Setting.plugin_issue_table_macro['issue_table_status']
            str += "<td>#{r.status}</td>"
          end
          if Setting.plugin_issue_table_macro['issue_table_fixed_version']
            str += "<td>#{r.fixed_version}</td>"
          end
          if Setting.plugin_issue_table_macro['issue_table_priority']
            str += "<td>#{r.priority}</td>"
          end
          if Setting.plugin_issue_table_macro['issue_table_category']
            str += "<td>#{r.category}</td>"
          end
          if Setting.plugin_issue_table_macro['issue_table_subject']
            str += "<td>#{r.subject}</td>"
          end
          if Setting.plugin_issue_table_macro['issue_table_author']
            str += "<td>#{link_to_user(r.author)}</td>"
          end
          if Setting.plugin_issue_table_macro['issue_table_assigned_to']
            str += "<td>#{link_to_user(r.assigned_to)}</td>"
          end
          if Setting.plugin_issue_table_macro['issue_table_start_date']
            str += "<td>#{format_date(r.start_date)}</td>"
          end
          if Setting.plugin_issue_table_macro['issue_table_due_date']
            str += "<td>#{format_date(r.due_date)}</td>"
          end
          str += "</tr>"
          i += 1
        end
        str += "</table>"
      end

      return str.html_safe
    end
  end
